<?php

include_once "WEBON_COUNTER.php";
include_once "WEBON_DATE.php";
include_once "WEBON_DB_CONNECT.php";

final class WEBON_COUNTER_BASIC extends WEBON_COUNTER implements WEBON_DB_CONNECT {


	public function __construct(){
		$db="";
		$no=1;
		$access_time=0;
		$access_date=0;
		$host="test";
		$ip="test";
		$browser_os="test";
		$pageid=0;

		$this->setNo($no);
		$this->setAccess_time($access_time);
		$this->setAccess_date($access_date);
		$this->setHost($host);
		$this->setIp($ip);
		$this->setBrowser_os($browser_os);
		$this->setPageid($pageid);
	}

	public function DB_CONNECT($selected_db,$user,$pass,$server,$db_name){
	        $db =& DB::connect("$selected_db://$user:$pass@$server/$db_name");
		if (DB::isError($db)) {
			echo "<br />";
			echo "selected_db:"."$selected_db";
			echo "<br />";
			echo "user:"."$user";
			echo "<br />";
			echo "pass:"."$pass";
			echo "<br />";
			echo "server:"."$server";
			echo "<br />";
			echo "db_name:"."$db_name";
			echo "<br />";
			die($db->getMessage());
		}
        	$this->setDb($db);
		return $this;
	} 

        public function create(){
                $db=$this->getDb();
                if(DB::isError($db)){
                        die($db->getMessage());
                }
                $sql = "create table counter (
                        no integer primary key,
                        access_time integer not null,
                        host varchar(100) not null,
                        ip varchar(50) not null,
                        browser_os varchar(300) not null,
                        pageid integer references link_left(no)
                        )";
                $res=$db->query($sql);
                if(DB::isError($res)){
			echo "<br />";
			echo "Failed to create table counter !";
			echo "<br />";
                        die($res->getMessage());
                }
                $sql = "grant all on counter to public";
                $res=$db->query($sql);
                if(DB::isError($res)){
			echo "<br />";
			echo "Failed to grant all on table counter !";
			echo "<br />";
                        die($res->getMessage());
                }
                $success = 1;
                return $success;
        }

        public function count(){
                $db=$this->getDb();
                if(DB::isError($db)){
                        die($db->getMessage());
                }
                $sql = "select no from counter order by no desc limit 1";
                $res=$db->query($sql);
                if(DB::isError($res)){
                        die($res->getMessage());
                }
                while($row=& $res->fetchRow()){
                        $numbers=$row[0];
                }
                return $numbers;
        }

        public function count_visited_people(){
                $db=$this->getDb();
                if(DB::isError($db)){
                        die($db->getMessage());
                }
		$sql = "select count(distinct(ip)) from counter";
                $res=$db->query($sql);
                if(DB::isError($res)){
                        die($res->getMessage());
                }
                while($row=& $res->fetchRow()){
                        $numbers=$row[0];
                }
                return $numbers;
        }

        public function select($howmany,$cnt){
                $aryWEBON=array();
                $db=$this->getDb();
                if (DB::isError($db)) {
                    die($db->getMessage());
                }

                $res=$db->query("select no,access_time,ip,host,browser_os,pageid
                                from counter
                                order by no desc limit $howmany offset $cnt
                                ");
                if (DB::isError($res)) {
                        echo "cnt:"."$cnt";
                        echo "<br />";
                        echo "howmany:"."$howmany";
                        echo "<br />";
                    die($res->getMessage());
                }
                while($row=& $res->fetchRow(DB_FETCHMODE_ASSOC)){
                        $i_webon=new WEBON_COUNTER_BASIC();
                        $no=$row["no"];
                        $access_time=$row["access_time"];
                        $date_obj=new WEBON_DATE($access_time);
			$year=$date_obj->getYear();
			$month=$date_obj->getMon();
			$mday=$date_obj->getMday();
			$hours=$date_obj->getHours();
			$minutes=$date_obj->getMinutes();
			$seconds=$date_obj->getSeconds();
			$access_date="$year"."/"."$month"."/"."$mday"."/"."$hours".":"."$minutes".":"."$seconds";

                        $ip=$row["ip"];
                        $host=$row["host"];
                        $browser_os=$row["browser_os"];
                        $pageid=$row["pageid"];

                        $i_webon->setNo($no);
                        $i_webon->setAccess_time($access_time);
                        $i_webon->setAccess_date($access_date);
                        $i_webon->setIp($ip);
                        $i_webon->setHost($host);
                        $i_webon->setBrowser_os($browser_os);
                        $i_webon->setPageid($pageid);

                $aryWEBON[]=$i_webon;
                }
                return $aryWEBON;
        }

	public function insert($pageid,$r_sub_title){
		$access_time = time();
		$ip = $_SERVER["REMOTE_ADDR"];
		$browser_os = $_SERVER["HTTP_USER_AGENT"];
		$host = gethostbyaddr($ip);
		$pageid = escapeshellcmd(htmlspecialchars($pageid));
		$r_sub_title = escapeshellcmd(htmlspecialchars($r_sub_title));
		$no_from_db=$this->count();
		$no_insert="$no_from_db"+"1";
		$table_name   = 'counter';
		$table_fields = array('no','access_time','host','ip','browser_os','pageid');
		$db=$this->getDb();
		$sth = $db->autoPrepare($table_name, $table_fields,
				    DB_AUTOQUERY_INSERT);
		if (DB::isError($sth)) {
			die($sth->getMessage());
		}
		$table_values = array($no_insert,$access_time,$host,$ip,$browser_os,$pageid);
		$res =& $db->execute($sth, $table_values);

		if (DB::isError($res)) {
			echo "err_insert";
			echo "<br />";
			echo "no_insert:"."$no_insert";	
			echo "<br />";
			echo "access_time:"."$access_time";	
			echo "<br />";
			echo "host:"."$host";	
			echo "<br />";
			echo "ip:"."$ip";	
			echo "<br />";
			echo "browser_os:"."$browser_os";	
			echo "<br />";
			echo "pageid:"."$pageid";	
			echo "<br />";
			echo "sub_title:"."$r_sub_title";	
			echo "<br />";
			die($res->getMessage());
		}
		return $no_insert;
	}

	public function __destruct(){}

	public function setDb($db){
		$this->db=$db;
	}
	public function setNo($no){
		$this->no=$no;
	}
	public function setAccess_time($access_time){
		$this->access_time=$access_time;
	}
	public function setAccess_date($access_date){
		$this->access_date=$access_date;
	}
	public function setHost($host){
		$this->host=$host;
	}
	public function setIp($ip){
		$this->ip=$ip;
	}
	public function setBrowser_os($browser_os){
		$this->browser_os=$browser_os;
	}
	public function setPageid($pageid){
		$this->pageid=$pageid;
	}
		
	public function getDb(){
		return $this->db;
	}
	public function getNo(){
		return $this->no;
	}
	public function getAccess_time(){
		return $this->access_time;
	}
	public function getAccess_date(){
		return $this->access_date;
	}
	public function getHost(){
		return $this->host;
	}
	public function getIp(){
		return $this->ip;
	}
	public function getBrowser_os(){
		return $this->browser_os;
	}
	public function getPageid(){
		return $this->pageid;
	}
}
?>
