<?php

include_once "WEBON_TABLE_CONTENTS.php";
include_once "WEBON_DB_CONNECT.php";

final class WEBON_TABLE_CONTENTS_BODY extends WEBON_TABLE_CONTENTS implements WEBON_DB_CONNECT {
	public function __construct(){
		$no=1;
		$link_left_no=1;
		$sub_title="test";
		$body="test";

		$this->setNo($no);
		$this->setLink_left_no($link_left_no);
		$this->setSub_title($sub_title);
		$this->setBody($body);
	}

	public function DB_CONNECT($selected_db,$user,$pass,$server,$db_name){
	        $db =& DB::connect("$selected_db://$user:$pass@$server/$db_name");
			if (DB::isError($db)) {
				echo "<br />";
				echo "selected_db:"."$selected_db";
				echo "<br />";
				echo "user:"."$user";
				echo "<br />";
				echo "pass:"."$pass";
				echo "<br />";
				echo "server:"."$server";
				echo "<br />";
				echo "db_name:"."$db_name";
				echo "<br />";
				die($db->getMessage());
		}
        	$this->setDb($db);

		return $this;
	} 

	public function __destruct(){}

        public function create(){
                $db=$this->getDb();
                if(DB::isError($db)){
                        die($db->getMessage());
                }
                $sql = "create table contents (
                        no integer primary key,
                        link_left_no integer references link_left(no),
                        sub_title varchar(100) references link_left(link_char),
                        body varchar(200000) not null 
                        )";
                $res=$db->query($sql);
                if(DB::isError($res)){
			echo "<br />";
			echo "failed to create table contents ! ";
			echo "<br />";
                        die($res->getMessage());
                }
		$this->insert(1,'index','test');
                $sql = "grant all on table contents to public";
                $res=$db->query($sql);
                if(DB::isError($res)){
			echo "<br />";
			echo "failed to grant all on table contents ! ";
			echo "<br />";
                        die($res->getMessage());
                }
                $success = 1;
                return $success;
        }


        public function count(){
                $db=$this->getDb();
                if(DB::isError($db)){
                        die($db->getMessage());
                }
                $sql = "select no from contents order by no desc limit 1";
                $res=$db->query($sql);
                if(DB::isError($res)){
                        die($res->getMessage());
                }
                while($row=& $res->fetchRow()){
                        $numbers=$row[0];
                }
                return $numbers;
        }

	public function insert($r_link_left_no,$r_sub_title,$r_body){
		$r_link_left_no = escapeshellcmd(htmlspecialchars($r_link_left_no));
		$r_sub_title = escapeshellcmd(htmlspecialchars($r_sub_title));
		$r_body = escapeshellcmd(htmlspecialchars($r_body));
		$no_from_db=$this->count();
		$no_insert="$no_from_db"+"1";
		$table_name   = 'contents';
		$table_fields = array('no','link_left_no','sub_title','body');
		$db=$this->getDb();
		$sth = $db->autoPrepare($table_name, $table_fields,
				    DB_AUTOQUERY_INSERT);
		if (DB::isError($sth)) {
			die($sth->getMessage());
		}
		$table_values = array($no_insert,$r_link_left_no,$r_sub_title,$r_body);
		$res =& $db->execute($sth, $table_values);

		if (DB::isError($res)) {
			echo "err_insert";
			echo "no_insert:"."$no_insert";	
			echo "<br />";
			echo "link_left_no:"."$r_link_left_no";	
			echo "<br />";
			echo "sub_title:"."$r_sub_title";	
			echo "<br />";
			echo "body:"."$r_body";	
			echo "<br />";
			die($res->getMessage());
		}
		return $no_insert;
	}

	public function select_link_left_no($r_sub_title){
		$aryWEBON=array();
		$db=$this->getDb();
		if (DB::isError($db)) {
		    die($db->getMessage());
		}
		
        	$res=$db->query("select link_left_no
				from contents  
				where sub_title='$r_sub_title' 
				");
		if (DB::isError($res)) {
			echo "<br />";
			echo "r_sub_title:"."$r_sub_title";
			echo "<br />";
		    die($res->getMessage());
		}
        	while($row=& $res->fetchRow(DB_FETCHMODE_ASSOC)){
			$link_left_no=$row["link_left_no"];
		}
		return $link_left_no;
	}


	public function select_sub_title($r_sub_title){
		$aryWEBON=array();
		$db=$this->getDb();
		if (DB::isError($db)) {
		    die($db->getMessage());
		}
		
        	$res=$db->query("select no,link_left_no,sub_title,body
				from contents  
				where sub_title='$r_sub_title' 
				");
		if (DB::isError($res)) {
			echo "<br />";
			echo "r_sub_title:"."$r_sub_title";
			echo "<br />";
		    die($res->getMessage());
		}
        	while($row=& $res->fetchRow(DB_FETCHMODE_ASSOC)){
			$i_webon=new WEBON_TABLE_CONTENTS_BODY();
			$no=$row["no"];
			$link_left_no=$row["link_left_no"];
			$sub_title=stripslashes($row["sub_title"]);
			$body=stripslashes($row["body"]);
			/*\n should be converted*/
			$body = str_replace("\n", "<br />", $body);
			$body = str_replace("&lt;", "<", $body);
			$body = str_replace("&gt;", ">", $body);
			$body = str_replace("&quot;", "\"", $body);
	
			$i_webon->setNo($no);
			$i_webon->setLink_left_no($link_left_no);
			$i_webon->setSub_title($sub_title);
			$i_webon->setBody($body);
		
			$aryWEBON[]=$i_webon;
		}
		return $aryWEBON;
	}

	public function select($r_link_left_no){
		$aryWEBON=array();
		$db=$this->getDb();
		if (DB::isError($db)) {
		    die($db->getMessage());
		}
		
        	$res=$db->query("select no,link_left_no,sub_title,body
				from contents  
				where link_left_no=$r_link_left_no 
				");
		if (DB::isError($res)) {
			echo "r_link_left_no:"."$r_link_left_no";
			echo "<br />";
		    die($res->getMessage());
		}
        	while($row=& $res->fetchRow(DB_FETCHMODE_ASSOC)){
			$i_webon=new WEBON_TABLE_CONTENTS_BODY();
			$no=$row["no"];
			$link_left_no=$row["link_left_no"];
			$sub_title=stripslashes($row["sub_title"]);
			$body=stripslashes($row["body"]);
			/*\n should not be converted*/
			$body = str_replace("&lt;", "<", $body);
			$body = str_replace("&gt;", ">", $body);
			$body = str_replace("&quot;", "\"", $body);
	
			$i_webon->setNo($no);
			$i_webon->setLink_left_no($link_left_no);
			$i_webon->setSub_title($sub_title);
			$i_webon->setBody($body);
		
			$aryWEBON[]=$i_webon;
		}
		return $aryWEBON;
	}

	public function update($r_no,$r_sub_title,$r_body){
		$no = escapeshellcmd(htmlspecialchars($r_no));
		$sub_title = escapeshellcmd(htmlspecialchars($r_sub_title));
		$body = escapeshellcmd(htmlspecialchars($r_body));
                $db = $this->getDb();
                $table_name   = 'contents';
                $table_fields = array('sub_title','body');
                $sth = $db->autoPrepare($table_name, $table_fields,
                                    DB_AUTOQUERY_UPDATE,"no =$no");
                $table_values = array($sub_title,$body);

                if (DB::isError($sth)) {
                        echo "err_update_prepare";
                die($sth->getMessage());
                }

                $res =& $db->execute($sth, $table_values);

                if (DB::isError($res)) {
                        echo "err_update_execute";
			echo "<br />";
                        echo "no"."$no";
			echo "<br />";
                        echo "sub_title"."$sub_title";
			echo "<br />";
                        echo "body"."$body";
			echo "<br />";
                        die($res->getMessage());
                }
	}

	public function setDb($db){
		$this->db=$db;
	}
	public function setNo($no){
		$this->no=$no;
	}
	public function setLink_left_no($link_left_no){
		$this->link_left_no=$link_left_no;
	}
	public function setSub_title($sub_title){
		$this->sub_title=$sub_title;
	}
	public function setBody($body){
		$this->body=$body;
	}
		
	public function getDb(){
		return $this->db;
	}
	public function getNo(){
		return $this->no;
	}
	public function getLink_left_no(){
		return $this->link_left_no;
	}
	public function getSub_title(){
		return $this->sub_title;
	}
	public function getBody(){
		return $this->body;
	}
}
?>
