<?php

include_once "WEBON_TABLE_LINK.php";
include_once "WEBON_DB_CONNECT.php";

final class WEBON_TABLE_LINK_RIGHT extends WEBON_TABLE_LINK implements WEBON_DB_CONNECT {
	public function __construct(){
		$no=1;
		$link_char="test";
		$link_explain="test";
		$seniority=1;

		$this->setNo($no);
		$this->setLink_char($link_char);
		$this->setLink_explain($link_explain);
		$this->setSeniority($seniority);
	}

	public function DB_CONNECT($selected_db,$user,$pass,$server,$db_name){
	        $db =& DB::connect("$selected_db://$user:$pass@$server/$db_name");
			if (DB::isError($db)) {
				echo "<br />";
				echo "selected_db:"."$selected_db";
				echo "<br />";
				echo "user:"."$user";
				echo "<br />";
				echo "pass:"."$pass";
				echo "<br />";
				echo "server:"."$server";
				echo "<br />";
				echo "db_name:"."$db_name";
				echo "<br />";
				die($db->getMessage());
		}
        	$this->setDb($db);

		return $this;
	} 

	public function __destruct(){}
	public function create(){
		$db=$this->getDb();
		if(DB::isError($db)){
			die($db->getMessage());
		}
		$sql = "create table link_right (
			no integer primary key,
			link_char varchar(100) not null unique,
			link_explain varchar(100) not null unique,
			seniority integer not null
			)";
		$res=$db->query($sql);
		if(DB::isError($res)){
			echo "<br />";
			echo "Failed to create table link_right !";
			echo "<br />";
			die($res->getMessage());
		}
		$sql = "grant all on table link_right to public";
		$res=$db->query($sql);
		if(DB::isError($res)){
			echo "<br />";
			echo "Failed to grant all on table link_right !";
			echo "<br />";
			die($res->getMessage());
		}
		$success = 1;
		return $success;
	}
	
	public function select($howmany,$cnt){
		$aryWEBON=array();
		$db=$this->getDb();
		if (DB::isError($db)) {
		    die($db->getMessage());
		}
		
        	$res=$db->query("select no,link_char,link_explain,seniority
				from link_right  
				order by seniority limit $howmany offset $cnt 
				");
		if (DB::isError($res)) {
			echo "cnt:"."$cnt";
			echo "howmany:"."$howmany";
			echo "<br />";
		    die($res->getMessage());
		}
        	while($row=& $res->fetchRow(DB_FETCHMODE_ASSOC)){
			$i_webon=new WEBON_TABLE_LINK_RIGHT();
			$no=$row["no"];
			$link_char=$row["link_char"];
			$link_explain=stripslashes($row["link_explain"]);
			$seniority=$row["seniority"];
	
			$i_webon->setNo($no);
			$i_webon->setLink_char($link_char);
			$i_webon->setLink_explain($link_explain);
			$i_webon->setSeniority($seniority);
		
		$aryWEBON[]=$i_webon;
		}
		return $aryWEBON;
	}

	public function count(){
		$db=$this->getDb();
		if(DB::isError($db)){
			die($db->getMessage());
		}
		$sql = "select no from link_right order by no desc limit 1";
		$res=$db->query($sql);
		if(DB::isError($res)){
			die($res->getMessage());
		}
		while($row=& $res->fetchRow()){
			$numbers=$row[0];
		}
		return $numbers;
	}	
	public function insert($link_char,$link_explain,$seniority){
		$link_char = escapeshellcmd(htmlspecialchars($link_char));
		$link_explain = escapeshellcmd(htmlspecialchars($link_explain));
		$seniority = escapeshellcmd(htmlspecialchars($seniority));
		$no_from_db=$this->count();
		$no_insert="$no_from_db"+"1";
		$table_name   = 'link_right';
		$table_fields = array('no','link_char','link_explain','seniority');
		$db=$this->getDb();
		$sth = $db->autoPrepare($table_name, $table_fields,
				    DB_AUTOQUERY_INSERT);
		if (DB::isError($sth)) {
		die($sth->getMessage());
		}
		$table_values = array($no_insert,$link_char,$link_explain,$seniority);
		$res =& $db->execute($sth, $table_values);

		if (DB::isError($res)) {
			echo "err_insert";
			echo "no_insert:"."$no_insert";	
			echo "<br />";
			echo "link_char:"."$link_char";	
			echo "<br />";
			echo "link_explain:"."$link_explain";	
			echo "<br />";
			echo "seniority:"."$seniority";	
			echo "<br />";
			die($res->getMessage());
		}
		return $no_insert;
	}

	public function update($r_no,$r_link_char,$r_link_explain,$r_seniority){
		$no = escapeshellcmd(htmlspecialchars($r_no));
		$link_char = escapeshellcmd(htmlspecialchars($r_link_char));
		$link_explain = escapeshellcmd(htmlspecialchars($r_link_explain));
		$seniority = escapeshellcmd(htmlspecialchars($r_seniority));
                $db = $this->getDb();
                $table_name   = 'link_right';
                $table_fields = array('link_char','link_explain','seniority');
                $sth = $db->autoPrepare($table_name, $table_fields,
                                    DB_AUTOQUERY_UPDATE,"no =$no");
                $table_values = array($link_char,$link_explain,$seniority);

                if (DB::isError($sth)) {
                        echo "err_update_prepare";
                die($sth->getMessage());
                }

                $res =& $db->execute($sth, $table_values);

                if (DB::isError($res)) {
                        echo "err_update_execute";
                        echo "<br />";
                        echo "$no_update";
                        echo "<br />";
                        die($res->getMessage());
                }
	}

	public function delete($no){
		$no = escapeshellcmd(htmlspecialchars($no));
                $db = $this->getDb();
                $table_name   = 'link_right';
		$sql = "delete from $table_name where no=$no";
                $res = $db->query($sql);

                if (DB::isError($res)) {
                        echo "err_delete";
                        echo "<br />";
                        echo "$no";
                        echo "<br />";
                        die($res->getMessage());
                }
	}

	public function setDb($db){
		$this->db=$db;
	}
	public function setNo($no){
		$this->no=$no;
	}
	public function setLink_char($link_char){
		$this->link_char=$link_char;
	}
	public function setLink_explain($link_explain){
		$this->link_explain=$link_explain;
	}
	public function setSeniority($seniority){
		$this->seniority=$seniority;
	}
		
	public function getDb(){
		return $this->db;
	}
	public function getNo(){
		return $this->no;
	}
	public function getLink_char(){
		return $this->link_char;
	}
	public function getLink_explain(){
		return $this->link_explain;
	}
	public function getSeniority(){
		return $this->seniority;
	}
}
?>
