<?php
//include class file
include_once 'XML/Serializer.php';

//set options
$options = array(
		"mode" => "simplexml",
		"indent" => "	",
		"linebreak" => "\n",
		"typeHints" => false,
		"addDecl" => true,
		"addDoctype" => true,
		"encoding" => 'UTF-8',
		"rootName" => "rss",
		"rootAttributes" => array("version" => "2.0"),
		"defaultTagName" => "item"
	);
//create object
$serializer = new XML_Serializer($options);

//open connection to database
$db = pg_connect("host=localhost port=5432 dbname=webon user=postgres password=postgres");

//execute query
$query = "select contents.body,contents.sub_title
		from link_left,contents 
		where link_left.no=contents.link_left_no
		order by link_left.seniority";

$result = pg_query($db,$query);
while($row=pg_fetch_array($result))
{
	$body = $row[0];
	$body = str_replace("\n", "-linebreake-", $body);
	$body = stripslashes($body);
	/*if i do this tag appears...*/
	//	$body = str_replace("\n", "<br />", $body);
	$body = str_replace("&lt;", "<", $body);
	$body = str_replace("&gt;", ">", $body);
	$body = str_replace("&quot;", "\"", $body);
	$body = strip_tags($body);
	/*it does not work...*/
	$body = str_replace("-linebreake-","\n",$body);
	/*end it does not work...*/
	$body = substr($body,0,500);
	$sub_title = $row[1];
	$xml[] = array (
			"title" => "$sub_title",
			"link" => "http://yoursite-name.net/?contents_request=on&body_request=$sub_title",
			"title" => "$sub_title",
			"description" => "$body"."..."
	);
}
//close detabase connection
pg_close($db);

$data['channel']=array(
		"title" => "your-title",
		"link" => "http://yoursite-name.net/",
		"title" => "your title",
		"description" => "what's new",
		$xml
);

if($serializer->serialize($data)){
	header('Content-type: text/xml');
	echo $serializer->getSerializedData();
}

?>
